Index: issm/trunk/src/c/modules/IoModelToConstraintsx/IoModelToConstraintsx.cpp
===================================================================
--- issm/trunk/src/c/modules/IoModelToConstraintsx/IoModelToConstraintsx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/IoModelToConstraintsx/IoModelToConstraintsx.cpp	(revision 13395)
@@ -38,6 +38,6 @@
 	fid=iomodel->SetFilePointerToData(&code, &vector_layout,vector_enum);
 
-	if(code!=7)_error2_("expecting a IssmDouble vector for constraints with enum " << EnumToStringx(vector_enum));
-	if(vector_layout!=1)_error2_("expecting a nodal vector for constraints with enum " << EnumToStringx(vector_enum));
+	if(code!=7)_error_("expecting a IssmDouble vector for constraints with enum " << EnumToStringx(vector_enum));
+	if(vector_layout!=1)_error_("expecting a nodal vector for constraints with enum " << EnumToStringx(vector_enum));
 
 	/*Fetch vector:*/
@@ -99,5 +99,5 @@
 	}
 	else{
-		_error2_("Size of field " << EnumToStringx(vector_enum) << " not supported");
+		_error_("Size of field " << EnumToStringx(vector_enum) << " not supported");
 	}
 
Index: issm/trunk/src/c/modules/IoModelToConstraintsx/IoModelToConstraintsx.h
===================================================================
--- issm/trunk/src/c/modules/IoModelToConstraintsx/IoModelToConstraintsx.h	(revision 12709)
+++ issm/trunk/src/c/modules/IoModelToConstraintsx/IoModelToConstraintsx.h	(revision 13395)
@@ -6,5 +6,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/trunk/src/c/modules/KMLFileReadx/KMLFileReadx.h
===================================================================
--- issm/trunk/src/c/modules/KMLFileReadx/KMLFileReadx.h	(revision 12709)
+++ issm/trunk/src/c/modules/KMLFileReadx/KMLFileReadx.h	(revision 13395)
@@ -8,5 +8,5 @@
 #include <float.h>    /*  DBL_MAX  */
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/trunk/src/c/modules/KMLMeshWritex/KMLMeshWritex.cpp
===================================================================
--- issm/trunk/src/c/modules/KMLMeshWritex/KMLMeshWritex.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/KMLMeshWritex/KMLMeshWritex.cpp	(revision 13395)
@@ -133,5 +133,5 @@
 					}
 					else
-						_error2_("Nodal connectivity table needs more than specified " << mxepg << " columns.\n");
+						_error_("Nodal connectivity table needs more than specified " << mxepg << " columns.\n");
 				}
 				jpt++;
@@ -173,5 +173,5 @@
 
 		else
-			_error2_("Data matrix has incorrect number of " << mdata << " rows.\n");
+			_error_("Data matrix has incorrect number of " << mdata << " rows.\n");
 	}
 
Index: issm/trunk/src/c/modules/KMLMeshWritex/KMLMeshWritex.h
===================================================================
--- issm/trunk/src/c/modules/KMLMeshWritex/KMLMeshWritex.h	(revision 12709)
+++ issm/trunk/src/c/modules/KMLMeshWritex/KMLMeshWritex.h	(revision 13395)
@@ -8,5 +8,5 @@
 #include <float.h>    /*  DBL_MAX  */
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/trunk/src/c/modules/KMLOverlayx/KMLOverlayx.h
===================================================================
--- issm/trunk/src/c/modules/KMLOverlayx/KMLOverlayx.h	(revision 12709)
+++ issm/trunk/src/c/modules/KMLOverlayx/KMLOverlayx.h	(revision 13395)
@@ -8,5 +8,5 @@
 #include <float.h>    /*  DBL_MAX  */
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/trunk/src/c/modules/Kml2Expx/Kml2Expx.cpp
===================================================================
--- issm/trunk/src/c/modules/Kml2Expx/Kml2Expx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/Kml2Expx/Kml2Expx.cpp	(revision 13395)
@@ -44,5 +44,5 @@
 	fidi=fopen(filkml,"r");
 	if (!(kobj=KMLFileReadx(fidi)))
-		_error2_("Error reading kml file.");
+		_error_("Error reading kml file.");
 	fclose(fidi);
 
Index: issm/trunk/src/c/modules/Kml2Expx/Kml2Expx.h
===================================================================
--- issm/trunk/src/c/modules/Kml2Expx/Kml2Expx.h	(revision 12709)
+++ issm/trunk/src/c/modules/Kml2Expx/Kml2Expx.h	(revision 13395)
@@ -8,5 +8,5 @@
 #include <float.h>    /*  DBL_MAX  */
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/trunk/src/c/modules/Krigingx/Krigingx.cpp
===================================================================
--- issm/trunk/src/c/modules/Krigingx/Krigingx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/Krigingx/Krigingx.cpp	(revision 13395)
@@ -7,5 +7,5 @@
 #include "../../include/include.h"
 #include "../../toolkits/toolkits.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../Container/Observations.h"
 #include "../modules.h"
@@ -48,5 +48,5 @@
 
 	/*Get output*/
-	options->Get(&output,"output","prediction");
+	options->Get(&output,"output",(char*)"prediction");
 
 	if(strcmp(output,"quadtree")==0){
@@ -96,4 +96,6 @@
 	}
 	else if(strcmp(output,"idw")==0){ //Inverse distance weighting
+		double power;
+		options->Get(&power,"power",2.);
 		/*initialize thread parameters: */
 		gate.n_interp     = n_interp;
@@ -108,4 +110,5 @@
 		gate.error        = error;
 		gate.percent      = xNewZeroInit<double>(num);
+		gate.power        = power;
 
 		/*launch the thread manager with Krigingxt as a core: */
@@ -135,5 +138,5 @@
 	}
 	else{
-		_error2_("output '" << output << "' not supported yet");
+		_error_("output '" << output << "' not supported yet");
 	}
 
@@ -270,8 +273,8 @@
 	double       *error        = gate->error;
 	double       *percent      = gate->percent;
+	double        power        = gate->power;
 
 	/*Intermediaries*/
 	double localpercent;
-	double  power = 2.;
 
 	/*partition loop across threads: */
@@ -302,5 +305,5 @@
 		else if(strcmp(model,"spherical")==0)   variogram = new SphericalVariogram(options);
 		else if(strcmp(model,"power")==0)       variogram = new PowerVariogram(options);
-		else _error2_("variogram " << model << " not supported yet (list of supported variogram: gaussian, exponential, spherical and power)");
+		else _error_("variogram " << model << " not supported yet (list of supported variogram: gaussian, exponential, spherical and power)");
 	}
 	else variogram = new GaussianVariogram(options);
Index: issm/trunk/src/c/modules/Krigingx/Krigingx.h
===================================================================
--- issm/trunk/src/c/modules/Krigingx/Krigingx.h	(revision 12709)
+++ issm/trunk/src/c/modules/Krigingx/Krigingx.h	(revision 13395)
@@ -6,5 +6,5 @@
 #define _KRIGINGX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../toolkits/toolkits.h"
 
@@ -29,4 +29,5 @@
 	double       *error;
 	double       *percent;
+	double        power;//for idw
 }KrigingxThreadStruct;
 
Index: issm/trunk/src/c/modules/Krigingx/pKrigingx.cpp
===================================================================
--- issm/trunk/src/c/modules/Krigingx/pKrigingx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/Krigingx/pKrigingx.cpp	(revision 13395)
@@ -7,5 +7,5 @@
 #include "../../include/include.h"
 #include "../../toolkits/toolkits.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../Container/Container.h"
 #include "../../io/io.h"
@@ -41,5 +41,5 @@
 
 	/*Get output*/
-	options->Get(&output,"output","prediction");
+	options->Get(&output,"output",(char*)"prediction");
 
 	if(strcmp(output,"quadtree")==0){
@@ -56,8 +56,8 @@
 		/*partition loop across threads: */
 		for(int idx=my_rank;idx<n_interp;idx+=num_procs){
-			_pprintString_("\r      interpolation progress: "<<setw(6)<<setprecision(2)<<double(idx)/double(n_interp)*100<<"%");
+			_pprintLine_("      interpolation progress: "<<setw(6)<<setprecision(2)<<double(idx)/double(n_interp)*100<<"%");
 			observations->InterpolationKriging(&predictions[idx],&error[idx],x_interp[idx],y_interp[idx],radius,mindata,maxdata,variogram);
 		}
-		_pprintLine_("\r      interpolation progress: "<<fixed<<setw(6)<<setprecision(2)<<100.<<"%");
+		_pprintLine_("      interpolation progress: "<<fixed<<setw(6)<<setprecision(2)<<100.<<"%");
 
 #ifdef _HAVE_MPI_
@@ -74,8 +74,8 @@
 		/*partition loop across threads: */
 		for(int idx=my_rank;idx<n_interp;idx+=num_procs){
-			_pprintString_("\r      interpolation progress: "<<setw(6)<<setprecision(2)<<double(idx)/double(n_interp)*100<<"%");
+			_pprintLine_("      interpolation progress: "<<setw(6)<<setprecision(2)<<double(idx)/double(n_interp)*100<<"%");
 			observations->InterpolationNearestNeighbor(&predictions[idx],x_interp[idx],y_interp[idx],radius);
 		}
-		_pprintLine_("\r      interpolation progress: "<<fixed<<setw(6)<<setprecision(2)<<100.<<"%");
+		_pprintLine_("      interpolation progress: "<<fixed<<setw(6)<<setprecision(2)<<100.<<"%");
 
 #ifdef _HAVE_MPI_
@@ -91,8 +91,8 @@
 		/*partition loop across threads: */
 		for(int idx=my_rank;idx<n_interp;idx+=num_procs){
-			_pprintString_("\r      interpolation progress: "<<setw(6)<<setprecision(2)<<double(idx)/double(n_interp)*100<<"%");
+			_pprintLine_("      interpolation progress: "<<setw(6)<<setprecision(2)<<double(idx)/double(n_interp)*100<<"%");
 			observations->InterpolationIDW(&predictions[idx],x_interp[idx],y_interp[idx],radius,mindata,maxdata,power);
 		}
-		_pprintLine_("\r      interpolation progress: "<<fixed<<setw(6)<<setprecision(2)<<100.<<"%");
+		_pprintLine_("      interpolation progress: "<<fixed<<setw(6)<<setprecision(2)<<100.<<"%");
 
 #ifdef _HAVE_MPI_
@@ -103,5 +103,5 @@
 	}
 	else{
-		_error2_("output '" << output << "' not supported yet");
+		_error_("output '" << output << "' not supported yet");
 	}
 
@@ -126,5 +126,5 @@
 		else if(strcmp(model,"spherical")==0)   variogram = new SphericalVariogram(options);
 		else if(strcmp(model,"power")==0)       variogram = new PowerVariogram(options);
-		else _error2_("variogram " << model << " not supported yet (list of supported variogram: gaussian, exponential, spherical and power)");
+		else _error_("variogram " << model << " not supported yet (list of supported variogram: gaussian, exponential, spherical and power)");
 	}
 	else variogram = new GaussianVariogram(options);
Index: issm/trunk/src/c/modules/Ll2xyx/Ll2xyx.cpp
===================================================================
--- issm/trunk/src/c/modules/Ll2xyx/Ll2xyx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/Ll2xyx/Ll2xyx.cpp	(revision 13395)
@@ -52,5 +52,5 @@
 	double  T,rho,sl,tc,mc;
 
-	if((sgn!=1) && (sgn!=-1)) _error2_("Sign should be either +1 or -1.\n");
+	if((sgn!=1) && (sgn!=-1)) _error_("Sign should be either +1 or -1.\n");
 
 	delta = central_meridian;
@@ -123,5 +123,5 @@
 		if(flag) _pprintLine_("Info: creating coordinates in polar stereographic (Std Latitude: 71S Meridian: 0).");
 	}
-	else _error2_("Sign should be either +1 or -1.\n");
+	else _error_("Sign should be either +1 or -1.\n");
 
 	return;
Index: issm/trunk/src/c/modules/MassFluxx/MassFluxx.cpp
===================================================================
--- issm/trunk/src/c/modules/MassFluxx/MassFluxx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/MassFluxx/MassFluxx.cpp	(revision 13395)
@@ -10,5 +10,5 @@
 #include "../../EnumDefinitions/EnumDefinitions.h"
 
-void MassFluxx(double* pmass_flux, Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads,Materials* materials, Parameters* parameters,bool process_units){
+void MassFluxx(IssmDouble* pmass_flux, Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads,Materials* materials, Parameters* parameters,bool process_units){
 
 	int i,j;
@@ -20,11 +20,11 @@
 	
 	/*output: */
-	double mass_flux=0;
-	double all_mass_flux=0;
+	IssmDouble mass_flux=0;
+	IssmDouble all_mass_flux=0;
 
 	int  counter;
 
 	/*all segments: */
-	double** array=NULL;
+	IssmDouble** array=NULL;
 	int      M;
 	int*     mdims_array=NULL;
@@ -32,5 +32,5 @@
 
 	/*our segments of interest: */
-	double*  segments=NULL;
+	IssmDouble*  segments=NULL;
 	int      num_segments;
 
@@ -48,5 +48,5 @@
 	 * When we find one, use the element to compute the mass flux on the segment: */
 	for(i=0;i<num_segments;i++){
-		element_id=(int)*(segments+5*i+4);
+		element_id=reCast<int,IssmDouble>(*(segments+5*i+4));
 		for(j=0;j<elements->Size();j++){
 			element=(Element*)elements->GetObjectByOffset(j);
@@ -66,10 +66,10 @@
 	/*Free ressources:*/
 	for(j=0;j<M;j++){
-		double* matrix=array[j];
-		xDelete<double>(matrix);
+		IssmDouble* matrix=array[j];
+		xDelete<IssmDouble>(matrix);
 	}
 	xDelete<int>(mdims_array);
 	xDelete<int>(ndims_array);
-	xDelete<double*>(array);
+	xDelete<IssmDouble*>(array);
 	
 	/*Assign output pointers: */
Index: issm/trunk/src/c/modules/MassFluxx/MassFluxx.h
===================================================================
--- issm/trunk/src/c/modules/MassFluxx/MassFluxx.h	(revision 12709)
+++ issm/trunk/src/c/modules/MassFluxx/MassFluxx.h	(revision 13395)
@@ -7,8 +7,8 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
-void MassFluxx(double* pmass_flux, Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads,Materials* materials, Parameters* parameters,bool process_units);
+void MassFluxx(IssmDouble* pmass_flux, Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads,Materials* materials, Parameters* parameters,bool process_units);
 
 
Index: issm/trunk/src/c/modules/MaxAbsVxx/MaxAbsVxx.cpp
===================================================================
--- issm/trunk/src/c/modules/MaxAbsVxx/MaxAbsVxx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/MaxAbsVxx/MaxAbsVxx.cpp	(revision 13395)
@@ -9,10 +9,10 @@
 #include "../../EnumDefinitions/EnumDefinitions.h"
 
-void MaxAbsVxx( double* pmaxabsvx, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials,Parameters* parameters,bool process_units){
+void MaxAbsVxx( IssmDouble* pmaxabsvx, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials,Parameters* parameters,bool process_units){
 	
 	int i;
-	double maxabsvx;
-	double node_maxabsvx;
-	double element_maxabsvx;
+	IssmDouble maxabsvx;
+	IssmDouble node_maxabsvx;
+	IssmDouble element_maxabsvx;
 
 	/*Go through elements, and request velocity: */
Index: issm/trunk/src/c/modules/MaxAbsVxx/MaxAbsVxx.h
===================================================================
--- issm/trunk/src/c/modules/MaxAbsVxx/MaxAbsVxx.h	(revision 12709)
+++ issm/trunk/src/c/modules/MaxAbsVxx/MaxAbsVxx.h	(revision 13395)
@@ -7,8 +7,8 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
-void MaxAbsVxx( double* pmaxabsvx, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,bool process_units);
+void MaxAbsVxx( IssmDouble* pmaxabsvx, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,bool process_units);
 
 #endif  /* _MAXABSVXX_H */
Index: issm/trunk/src/c/modules/MaxAbsVyx/MaxAbsVyx.cpp
===================================================================
--- issm/trunk/src/c/modules/MaxAbsVyx/MaxAbsVyx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/MaxAbsVyx/MaxAbsVyx.cpp	(revision 13395)
@@ -9,10 +9,10 @@
 #include "../../EnumDefinitions/EnumDefinitions.h"
 
-void MaxAbsVyx( double* pmaxabsvy, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials,Parameters* parameters,bool process_units){
+void MaxAbsVyx( IssmDouble* pmaxabsvy, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials,Parameters* parameters,bool process_units){
 	
 	int i;
-	double maxabsvy;
-	double node_maxabsvy;
-	double element_maxabsvy;
+	IssmDouble maxabsvy;
+	IssmDouble node_maxabsvy;
+	IssmDouble element_maxabsvy;
 
 
Index: issm/trunk/src/c/modules/MaxAbsVyx/MaxAbsVyx.h
===================================================================
--- issm/trunk/src/c/modules/MaxAbsVyx/MaxAbsVyx.h	(revision 12709)
+++ issm/trunk/src/c/modules/MaxAbsVyx/MaxAbsVyx.h	(revision 13395)
@@ -7,8 +7,8 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
-void MaxAbsVyx( double* pmaxabsvy, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,bool process_units);
+void MaxAbsVyx( IssmDouble* pmaxabsvy, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,bool process_units);
 
 #endif  /* _MAXABSVYX_H */
Index: issm/trunk/src/c/modules/MaxAbsVzx/MaxAbsVzx.cpp
===================================================================
--- issm/trunk/src/c/modules/MaxAbsVzx/MaxAbsVzx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/MaxAbsVzx/MaxAbsVzx.cpp	(revision 13395)
@@ -9,10 +9,10 @@
 #include "../../EnumDefinitions/EnumDefinitions.h"
 
-void MaxAbsVzx( double* pmaxabsvz, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials,Parameters* parameters,bool process_units){
+void MaxAbsVzx( IssmDouble* pmaxabsvz, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials,Parameters* parameters,bool process_units){
 	
 	int i;
-	double maxabsvz;
-	double node_maxabsvz;
-	double element_maxabsvz;
+	IssmDouble maxabsvz;
+	IssmDouble node_maxabsvz;
+	IssmDouble element_maxabsvz;
 
 	/*Go through elements, and request velocity: */
Index: issm/trunk/src/c/modules/MaxAbsVzx/MaxAbsVzx.h
===================================================================
--- issm/trunk/src/c/modules/MaxAbsVzx/MaxAbsVzx.h	(revision 12709)
+++ issm/trunk/src/c/modules/MaxAbsVzx/MaxAbsVzx.h	(revision 13395)
@@ -7,8 +7,8 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
-void MaxAbsVzx( double* pmaxabsvz, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,bool process_units);
+void MaxAbsVzx( IssmDouble* pmaxabsvz, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,bool process_units);
 
 #endif  /* _MAXABSVZX_H */
Index: issm/trunk/src/c/modules/MaxVelx/MaxVelx.cpp
===================================================================
--- issm/trunk/src/c/modules/MaxVelx/MaxVelx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/MaxVelx/MaxVelx.cpp	(revision 13395)
@@ -10,10 +10,10 @@
 #include "../../EnumDefinitions/EnumDefinitions.h"
 
-void MaxVelx( double* pmaxvel, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials,Parameters* parameters,bool process_units){
+void MaxVelx( IssmDouble* pmaxvel, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials,Parameters* parameters,bool process_units){
 	
 	int i;
-	double maxvel;
-	double node_maxvel;
-	double element_maxvel;
+	IssmDouble maxvel;
+	IssmDouble node_maxvel;
+	IssmDouble element_maxvel;
 
 	/*Go through elements, and request velocity: */
Index: issm/trunk/src/c/modules/MaxVelx/MaxVelx.h
===================================================================
--- issm/trunk/src/c/modules/MaxVelx/MaxVelx.h	(revision 12709)
+++ issm/trunk/src/c/modules/MaxVelx/MaxVelx.h	(revision 13395)
@@ -7,8 +7,8 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
-void MaxVelx( double* pmaxvel, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,bool process_units);
+void MaxVelx( IssmDouble* pmaxvel, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,bool process_units);
 
 #endif  /* _MAXVELX_H */
Index: issm/trunk/src/c/modules/MaxVxx/MaxVxx.cpp
===================================================================
--- issm/trunk/src/c/modules/MaxVxx/MaxVxx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/MaxVxx/MaxVxx.cpp	(revision 13395)
@@ -9,10 +9,10 @@
 #include "../../EnumDefinitions/EnumDefinitions.h"
 
-void MaxVxx( double* pmaxvx, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials,Parameters* parameters,bool process_units){
+void MaxVxx( IssmDouble* pmaxvx, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials,Parameters* parameters,bool process_units){
 	
 	int i;
-	double maxvx;
-	double node_maxvx;
-	double element_maxvx;
+	IssmDouble maxvx;
+	IssmDouble node_maxvx;
+	IssmDouble element_maxvx;
 
 	/*Go through elements, and request velocity: */
Index: issm/trunk/src/c/modules/MaxVxx/MaxVxx.h
===================================================================
--- issm/trunk/src/c/modules/MaxVxx/MaxVxx.h	(revision 12709)
+++ issm/trunk/src/c/modules/MaxVxx/MaxVxx.h	(revision 13395)
@@ -6,8 +6,8 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
-void MaxVxx( double* pmaxvx, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,bool process_units);
+void MaxVxx( IssmDouble* pmaxvx, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,bool process_units);
 
 #endif  /* _MAXVXX_H */
Index: issm/trunk/src/c/modules/MaxVyx/MaxVyx.cpp
===================================================================
--- issm/trunk/src/c/modules/MaxVyx/MaxVyx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/MaxVyx/MaxVyx.cpp	(revision 13395)
@@ -9,10 +9,10 @@
 #include "../../EnumDefinitions/EnumDefinitions.h"
 
-void MaxVyx( double* pmaxvy, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials,Parameters* parameters,bool process_units){
+void MaxVyx( IssmDouble* pmaxvy, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials,Parameters* parameters,bool process_units){
 
 	int i;
-	double maxvy;
-	double node_maxvy;
-	double element_maxvy;
+	IssmDouble maxvy;
+	IssmDouble node_maxvy;
+	IssmDouble element_maxvy;
 
 	/*Go through elements, and request velocity: */
Index: issm/trunk/src/c/modules/MaxVyx/MaxVyx.h
===================================================================
--- issm/trunk/src/c/modules/MaxVyx/MaxVyx.h	(revision 12709)
+++ issm/trunk/src/c/modules/MaxVyx/MaxVyx.h	(revision 13395)
@@ -7,8 +7,8 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
-void MaxVyx( double* pmaxvy, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,bool process_units);
+void MaxVyx( IssmDouble* pmaxvy, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,bool process_units);
 
 #endif  /* _MAXVYX_H */
Index: issm/trunk/src/c/modules/MaxVzx/MaxVzx.cpp
===================================================================
--- issm/trunk/src/c/modules/MaxVzx/MaxVzx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/MaxVzx/MaxVzx.cpp	(revision 13395)
@@ -10,10 +10,10 @@
 #include "../../EnumDefinitions/EnumDefinitions.h"
 
-void MaxVzx( double* pmaxvz, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials,Parameters* parameters,bool process_units){
+void MaxVzx( IssmDouble* pmaxvz, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials,Parameters* parameters,bool process_units){
 	
 	int i;
-	double maxvz;
-	double node_maxvz;
-	double element_maxvz;
+	IssmDouble maxvz;
+	IssmDouble node_maxvz;
+	IssmDouble element_maxvz;
 
 	/*Go through elements, and request velocity: */
Index: issm/trunk/src/c/modules/MaxVzx/MaxVzx.h
===================================================================
--- issm/trunk/src/c/modules/MaxVzx/MaxVzx.h	(revision 12709)
+++ issm/trunk/src/c/modules/MaxVzx/MaxVzx.h	(revision 13395)
@@ -7,8 +7,8 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
-void MaxVzx( double* pmaxvz, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,bool process_units);
+void MaxVzx( IssmDouble* pmaxvz, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,bool process_units);
 
 #endif  /* _MAXVZX_H */
Index: issm/trunk/src/c/modules/Mergesolutionfromftogx/Mergesolutionfromftogx.cpp
===================================================================
--- issm/trunk/src/c/modules/Mergesolutionfromftogx/Mergesolutionfromftogx.cpp	(revision 12709)
+++ issm/trunk/src/c/modules/Mergesolutionfromftogx/Mergesolutionfromftogx.cpp	(revision 13395)
@@ -7,8 +7,8 @@
 #include "./Mergesolutionfromftogx.h"
 
-void	Mergesolutionfromftogx( Vector** pug, Vector* uf, Vector* ys, Nodes* nodes, Parameters* parameters, bool flag_ys0){
+void	Mergesolutionfromftogx( Vector<IssmDouble>** pug, Vector<IssmDouble>* uf, Vector<IssmDouble>* ys, Nodes* nodes, Parameters* parameters, bool flag_ys0){
 
 	/*output: */
-	Vector* ug=NULL;
+	Vector<IssmDouble>* ug=NULL;
 
 	/*intermediary: */
@@ -34,5 +34,5 @@
 
 	/*initialize ug: */
-	ug=new Vector(gsize);
+	ug=new Vector<IssmDouble>(gsize);
 
 	/*Merge f set back into g set: */
Index: issm/trunk/src/c/modules/Mergesolutionfromftogx/Mergesolutionfromftogx.h
===================================================================
--- issm/trunk/src/c/modules/Mergesolutionfromftogx/Mergesolutionfromftogx.h	(revision 12709)
+++ issm/trunk/src/c/modules/Mergesolutionfromftogx/Mergesolutionfromftogx.h	(revision 13395)
@@ -6,8 +6,8 @@
 #define _MERGESOLUTIONFROMFTOGX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
-void	Mergesolutionfromftogx( Vector** pug, Vector* uf, Vector* ys, Nodes* nodes, Parameters* parameters, bool flag_ys0=false);
+void	Mergesolutionfromftogx( Vector<IssmDouble>** pug, Vector<IssmDouble>* uf, Vector<IssmDouble>* ys, Nodes* nodes, Parameters* parameters, bool flag_ys0=false);
 
 #endif  /* _MERGESOLUTIONFROMFTOGX_H */
Index: issm/trunk/src/c/modules/MeshPartitionx/MeshPartitionx.h
===================================================================
--- issm/trunk/src/c/modules/MeshPartitionx/MeshPartitionx.h	(revision 12709)
+++ issm/trunk/src/c/modules/MeshPartitionx/MeshPartitionx.h	(revision 13395)
@@ -7,9 +7,117 @@
 
 #include "../../include/include.h"
+#include "../../EnumDefinitions/EnumDefinitions.h"
+
 
 /* local prototypes: */
-int MeshPartitionx(int** pepart, int** pnpart, int numberofelements,int numberofnodes,IssmDouble* elements,
-		int numberofelements2d,int numberofnodes2d,IssmDouble* elements2d,int numlayers,int elements_width, int dim,int numareas);
+template <class doubletype> 
+int MeshPartitionx(int** pepart, int** pnpart, int numberofelements,int numberofnodes,doubletype* elements,
+		int numberofelements2d,int numberofnodes2d,doubletype* elements2d,int numlayers,int elements_width, int dim,int num_procs){
+
+	int noerr=1;
+	int i,j;
+
+	/*Metis partitioning: */
+	int* epart=NULL;
+	int* npart=NULL;
+	int* index=NULL;
+
+	int* epart2d=NULL;
+	int* npart2d=NULL;
+	int* index2d=NULL;
+	int  count=0;
+
+	int  etype=1; //tria mesh see metis/Programs/Io.c
+	int  etype2d=1; //tria mesh see metis/Programs/Io.c
+	int  numflag=0;
+	int  edgecut=1;
+
+	if(dim==2){
+		epart=xNew<int>(numberofelements);
+		npart=xNew<int>(numberofnodes);
+		index=xNew<int>(elements_width*numberofelements);
+		for (i=0;i<numberofelements;i++){
+			for (j=0;j<elements_width;j++){
+				*(index+elements_width*i+j)=reCast<int>(*(elements+elements_width*i+j))-1; //-1 for C indexing in Metis
+			}
+		}
+
+		/*Partition using Metis:*/
+		if (num_procs>1){
+			#ifdef _HAVE_METIS_
+			METIS_PartMeshNodalPatch(&numberofelements,&numberofnodes, index, &etype, &numflag, &num_procs, &edgecut, epart, npart);
+			#else
+			_error_("metis has not beed installed. Cannot run with more than 1 cpu");
+			#endif
+		}
+		else if (num_procs==1){
+			/*METIS does not know how to deal with one cpu only!*/
+			for (i=0;i<numberofelements;i++) epart[i]=0;
+			for (i=0;i<numberofnodes;i++)    npart[i]=0;
+		}
+		else _error_("At least one processor is required");
+	}
+	else{
+		/*We have a 3d mesh, made of a regularly extruded 2d mesh. We first partition the 2d mesh, then we extrude the partition: */
+
+		/*First build concatenated 2d mesh  from 2d_coll and 2d_noncoll: */
+		epart2d=xNew<int>(numberofelements2d);
+		npart2d=xNew<int>(numberofnodes2d); 
+		index2d=xNew<int>(3*numberofelements2d);
+
+		for (i=0;i<numberofelements2d;i++){
+			for (j=0;j<3;j++){
+				*(index2d+3*i+j)=reCast<int>(*(elements2d+3*i+j))-1; //-1 for C indexing in Metis
+			}
+		}
+
+		/*Partition using Metis:*/
+		if (num_procs>1){
+			#ifdef _HAVE_METIS_
+			METIS_PartMeshNodalPatch(&numberofelements2d,&numberofnodes2d, index2d, &etype2d, &numflag, &num_procs, &edgecut, epart2d, npart2d);
+			#else
+			_error_("metis has not beed installed. Cannot run with more than 1 cpu");
+			#endif
+		}
+		else if (num_procs==1){
+			/*METIS does not know how to deal with one cpu only!*/
+			for (i=0;i<numberofelements2d;i++) epart2d[i]=0;
+			for (i=0;i<numberofnodes2d;i++)    npart2d[i]=0;
+		}
+		else _error_("At least one processor is required");
+
+		/*Extrude epart2d to epart, using numlayers: */
+		epart=xNew<int>(numberofelements);
+		
+		count=0;
+		for(i=0;i<(numlayers-1);i++){
+			for(j=0;j<numberofelements2d;j++){
+				epart[count]=epart2d[j];
+				count++;
+			}
+		}
+
+		/*Extrude npart2d to npart, using numlayers: */
+		npart=xNew<int>(numberofnodes);
+		
+		count=0;
+		for(i=0;i<(numlayers);i++){
+			for(j=0;j<numberofnodes2d;j++){
+				npart[count]=npart2d[j];
+				count++;
+			}
+		}
+	}
 	
+	/*Assign output pointer:*/
+	*pepart=epart;
+	*pnpart=npart;
+
+	/*Free ressources: */
+	xDelete<int>(index);
+	xDelete<int>(epart2d);
+	xDelete<int>(npart2d);
+	xDelete<int>(index2d);
+	return noerr;
+}	
 #endif /* _MESHPARTITIONX_H */
-
